package cc.fascinated.bat.features;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@RequiredArgsConstructor
@Getter
@Component
public abstract class Feature {
    /**
     * The name of the feature
     */
    private final String name;

    /**
     * The category of the feature
     */
    private final Category category;

    /**
     * The category of the feature
     */
    @AllArgsConstructor @Getter
    public enum Category {
        GENERAL("General"),
        MODERATION("Moderation"),
        SERVER("Server"),
        BEAT_SABER("Beat Saber");

        /**
         * The name of the category
         */
        private final String name;
    }
}
