package cc.fascinated.bat.features.autorole;

import cc.fascinated.bat.event.EventListener;
import cc.fascinated.bat.features.autorole.profile.AutoRoleProfile;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import lombok.extern.log4j.Log4j2;
import net.dv8tion.jda.api.entities.Role;
import net.dv8tion.jda.api.events.guild.member.GuildMemberJoinEvent;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@Log4j2
public class AutoRoleListener implements EventListener {
    @Override
    public void onGuildMemberJoin(@NonNull BatGuild guild, @NonNull BatUser user, @NonNull GuildMemberJoinEvent event) {
        AutoRoleProfile profile = guild.getProfile(AutoRoleProfile.class);
        if (profile.getRoles().isEmpty()) {
            return;
        }

        List<String> toRemove = new ArrayList<>();
        for (Role role : profile.getRoles()) {
            if (event.getGuild().getRoleById(role.getId()) == null) {
                toRemove.add(role.getId());
                continue;
            }
            event.getGuild().addRoleToMember(event.getMember(), role).queue();
        }
        toRemove.forEach(profile::removeRole);
        log.info("Gave user \"{}\" {} auto roles{}", user.getId(), profile.getRoles().size(), toRemove.isEmpty() ? ""
                : " and removed %s invalid roles".formatted(toRemove.size()));
    }
}
