package cc.fascinated.bat.model.token.beatsaber.scoresaber;

import lombok.Getter;
import lombok.ToString;

@Getter @ToString
public class ScoreSaberScoreToken {
    /**
     * The id for this score.
     */
    private String id;

    /**
     * The player info for this score.
     */
    private LeaderboardPlayerInfo leaderboardPlayerInfo;

    /**
     * The rank of this score.
     */
    private int rank;

    /**
     * The base score for this score.
     */
    private int baseScore;

    /**
     * The modified score for this score.
     */
    private int modifiedScore;

    /**
     * The PP for this score.
     */
    private double pp;

    /**
     * The weight for this score.
     */
    private int weight;

    /**
     * The modifiers for this score.
     */
    private String modifiers;

    /**
     * The multiplier for this score.
     */
    private int multiplier;

    /**
     * How many bad cuts this score has.
     */
    private int badCuts;

    /**
     * How many misses this score has.
     */
    private int missedNotes;

    /**
     * The maximum combo for this score.
     */
    private int maxCombo;

    /**
     * Whether this score was a full combo.
     */
    private boolean fullCombo;

    /**
     * The HMD that was used to set this score.
     */
    private int hmd;

    /**
     * The time set for this score.
     */
    private String timeSet;

    /**
     * Whether this score has a replay.
     */
    private boolean hasReplay;

    /**
     * The full HMD name that was used to set this score.
     */
    private String deviceHmd;

    /**
     * The controller that was used on the left hand.
     */
    private String deviceControllerLeft;

    /**
     * The controller that was used on the right hand.
     */
    private String deviceControllerRight;

    @Getter
    public class LeaderboardPlayerInfo {
        /**
         * The ID of the player.
         */
        private String id;

        /**
         * The name of the player.
         */
        private String name;

        /**
         * The profile picture of the player.
         */
        private String profilePicture;

        /**
         * The country of the player.
         */
        private String country;

        /**
         * The permissions for the player.
         */
        private int permissions;

        /**
         * The role for the player.
         */
        private String role;
    }
}
